## ukui-screensaver 2.0.1

=== Makefile ===
# The default options are compiling with debugging information
mode = debug

CC  = gcc
CXX = g++

# Source file directory
I18N_SRC = i18n_ts/

# bin file installation directory
BIN_DIR = /usr/bin

# gsettings xml file
GSETTINGS_DIR = /usr/share/glib-2.0/schemas

# desktop file
DESKTOP_DIR = /etc/xdg/autostart

# directory file
DIRECTORY_DIR = /usr/share/desktop-directories

# menus file
MENUS_DIR = /etc/xdg/menus

# Set build options
ifeq ($(mode), debug)
	# Compile with debugging information
	QMAKE_OPTIONS = CONFIG+=debug
else
	# Compile without debugging information
	QMAKE_OPTIONS =
endif

# Target
all: gui i18n command

#
# Compilation
#

# Compile GUI
gui:
	qmake src/ $(QMAKE_OPTIONS) -o Saver_Makefile
	$(MAKE) -f Saver_Makefile
	qmake backend/ $(QMAKE_OPTIONS) -o Backend_Makefile
	$(MAKE) -f Backend_Makefile
	qmake command/ $(QMAKE_OPTIONS) -o Command_Makefile
	$(MAKE) -f Command_Makefile

# Generate Qt translation file
i18n:
	$(MAKE) -C $(I18N_SRC)

command:
	$(CC) src/ukui-screensaver-command.c -o ukui-screensaver-command


#
# Installation
#

install: install-target install-i18n install-data

install-target:
	# Install target
	$(MAKE) -f Saver_Makefile install INSTALL_ROOT=$(DESTDIR)/
	$(MAKE) -f Backend_Makefile install INSTALL_ROOT=$(DESTDIR)/
	$(MAKE) -f Command_Makefile install INSTALL_ROOT=$(DESTDIR)/

install-i18n:
	# Install i18n
	$(MAKE) -C $(I18N_SRC) install

install-data:
	# Install gsettings file
	install -D -m 644 data/org.ukui.screensaver.gschema.xml $(DESTDIR)$(GSETTINGS_DIR)/org.ukui.screensaver.gschema.xml
	install -D -m 644 data/ukui-screensaver.desktop $(DESTDIR)$(DESKTOP_DIR)/ukui-screensaver.desktop
	install -D -m 644 data/ukui-screensavers.menu $(DESTDIR)$(MENUS_DIR)/ukui-screensavers.menu
	install -D -m 644 data/ukui-screensaver.directory $(DESTDIR)$(DIRECTORY_DIR)/ukui-screensaver.directory


#
# Uninstallation
#

uninstall: uninstall-target uninstall-i18n uninstall-data

uninstall-target:
	# Uninstall target
	$(MAKE) -f Saver_Makefile uninstall
	$(MAKE) -f Backend_Makefile uninstall
	$(MAKE) -f Command_Makefile uninstall

uninstall-i18n:
	# Uninstall i18n
	$(MAKE) -C $(I18N_SRC) uninstall

uninstall-data:
	# Uninstall data
	rm -rf $(DESTDIR)$(GSETTINGS_DIR)/org.ukui.screensaver.gschema.xml
	rm -rf $(DESTDIR)$(DESKTOP_DIR)/ukui-screensaver.desktop
	rm -rf $(DESTDIR)$(MENUS_DIR)/ukui-screensavers.menu
	rm -rf $(DESTDIR)$(DIRECTORY_DIR)/ukui-screensaver.directory

#
# Clean intermediate file
#

clean:
	# Clean GUI intermediate files
	rm -f *.o moc_* ui_* qrc_*.cpp
	rm -f Saver_Makefile Backend_Makefile Command_Makefile .qmake.stash
	rm -f ukui-screensaver-dialog ukui-screensaver-command ukui-screensaver-backend
	# Clean i18n intermediate files
	$(MAKE) -C $(I18N_SRC) clean

=== i18n_ts/Makefile ===
INSTALL_DIR_DATA = /usr/share/ukui-screensaver

all: zh_CN.qm

zh_CN.qm:
	lrelease zh_CN.ts -qm zh_CN.qm

clean:
	rm -f zh_CN.qm

install:
	install -m 666 -D zh_CN.qm $(DESTDIR)$(INSTALL_DIR_DATA)/i18n_qm/zh_CN.qm

uninstall:
	rm -f $(DESTDIR)$(INSTALL_DIR_DATA)/i18n_qm/zh_CN.qm

## ukui-screensaver 1.0.0

=== debian/changelog ===
ukui-screensaver (1.0.0-0ubuntu1) zesty; urgency=medium

  * Initial release. (LP: #1664247)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 07 Mar 2017 13:53:56 +0800

=== debian/control ===
Source: ukui-screensaver
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kylin Team <ukui@kylinos.cn>
Uploaders: Hao Li <lihao@kylinos.cn>,
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1.1),
               intltool,
               libdbus-glib-1-dev,
               libdconf-dev,
               libgl1-mesa-dev | libgl1-mesa-swx11-dev,
               libglib2.0-dev,
               libgtk-3-dev,
               libmate-desktop-dev,
               libmate-menu-dev,
               libmatekbd-dev,
               libnotify-dev,
               libpam0g-dev,
               libstartup-notification0-dev,
               libsystemd-dev [linux-any],
               libx11-dev,
               libxext-dev,
               libxss-dev,
               libxt-dev,
               libxxf86vm-dev,
               mate-common,
               x11proto-scrnsaver-dev,
               x11proto-xext-dev,
               x11proto-xf86vidmode-dev,
               xmlto,
Standards-Version: 3.9.8
Homepage: http://www.ukui.org/

Package: ukui-screensaver
Architecture: any
Depends: dbus-x11,
         mate-desktop-common,
         ukui-screensaver-common (= ${source:Version}),
         ukui-session-manager,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: mate-power-manager,
Suggests: rss-glx,
          xscreensaver-data,
Description: UKUI screen saver and locker
 ukui-screensaver is a screen saver and locker that aims to have simple,
 sane and secure defaults, and be well integrated with the UKUI desktop.
 .
 It is designed to support, among other things:
 .
  * the ability to lock down configuration settings
  * translation into other languages
  * user switching

Package: ukui-screensaver-common
Architecture: all
Depends: ${misc:Depends},
Description: UKUI screen saver and locker (common files)
 ukui-screensaver is a screen saver and locker that aims to have simple,
 sane and secure defaults, and be well integrated with the UKUI desktop.
 .
 This package contains the architecture independent files.

## ukui-screensaver 1.0.2

=== debian/changelog ===
ukui-screensaver (1.0.2-2) unstable; urgency=medium

  * Use tracker.d.o team address

 -- Aron Xu <aron@debian.org>  Mon, 09 Jul 2018 17:09:48 +0800

ukui-screensaver (1.0.2-1) unstable; urgency=medium

  * Initial release (Closes: #872968)

 -- Aron Xu <aron@debian.org>  Sat, 26 Aug 2017 15:26:45 +0800

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: ukui-screensaver
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kylin Team <ukui@kylinos.cn>
-Uploaders: Hao Li <lihao@kylinos.cn>,
-Build-Depends: debhelper (>= 9),
-               dpkg-dev (>= 1.16.1.1),
+Maintainer: Kylin Team <team+kylin@tracker.debian.org>
+Uploaders: Aron Xu <aron@debian.org>,
+           Hao Li <lihao@kylinos.cn>,
+Build-Depends: debhelper (>= 10),
                intltool,
                libdbus-glib-1-dev,
                libdconf-dev,
@@ -29,7 +28,7 @@
                x11proto-xext-dev,
                x11proto-xf86vidmode-dev,
                xmlto,
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.ukui.org/
 
 Package: ukui-screensaver

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUIULDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_HOST_ARCH_OS),linux)
        SYSTEMD_SUPPORT=--with-systemd
else
        SYSTEMD_SUPPORT=--without-systemd
endif

%:
	dh $@ $(DHFLAGS)

override_dh_install:
	rm -fv debian/tmp/usr/lib/*/*.la 
	rm -rfv debian/tmp/usr/share/omf/
	rm -rfv debian/tmp/usr/share/help/*/fdl/
	rm -rfv debian/tmp/usr/share/help/*/gpl/
	rm -rfv debian/tmp/usr/share/help/*/lgpl/
	# For Debian we ship our own ukui-screensaver PAM configuration...
	rm -rfv debian/tmp/etc/pam.d/ukui-screensaver
	dh_install --fail-missing

override_dh_auto_configure:
	# upstream tarball is without configure. autogen.sh will create it
	NOCONFIGURE=1 ./autogen.sh
	dh_auto_configure $(DHFLAGS) -- \
	        --disable-silent-rules \
	        --disable-static \
	        --with-xscreensaverdir=/usr/share/xscreensaver/config \
	        --with-xscreensaverhackdir=/usr/lib/xscreensaver \
	        --with-mit-ext \
	        --libexecdir=/usr/lib/ukui-screensaver \
	        --with-console-kit \
	        --with-libnotify \
	        --enable-locking \
	        --with-gtk=3.0 \
	        $(SYSTEMD_SUPPORT)

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## ukui-screensaver 1.0.3

=== debian/changelog ===
ukui-screensaver (1.0.3-0ubuntu1) artful; urgency=medium

  * [Fixed] screensaver-preferences can't preview "Blank Screen" correctly. (LP: #1683601)
  * [Obsolete Bug] (LP: #1683600)
  * [Improved] Change the unlock arrow to button.
  * [Improved] Set the font style of username label.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 13 Sep 2017 09:14:54 +0800

ukui-screensaver (1.0.2-0ubuntu1) artful; urgency=medium

  * New upstream release.
  * Replace the ukui log. (LP: #1686647) 
  * Move to GTK+3(>=3.14).

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 26 Jun 2017 15:26:45 +0800

ukui-screensaver (1.0.1-0ubuntu1) UNRELEASED; urgency=medium

  * Fix the error of missing user face image and username.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 11 Apr 2017 20:37:24 +0800

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: ukui-screensaver
 Section: x11
 Priority: optional
-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
-Uploaders: Aron Xu <aron@debian.org>,
-           Hao Li <lihao@kylinos.cn>,
-Build-Depends: debhelper (>= 10),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Kylin Team <ukui@kylinos.cn>
+Uploaders: Hao Li <lihao@kylinos.cn>,
+Build-Depends: debhelper (>= 9),
+               dpkg-dev (>= 1.16.1.1),
                intltool,
                libdbus-glib-1-dev,
                libdconf-dev,

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+DHFLAGS=--parallel
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUIULDFLAGS = 1
@@ -39,5 +41,8 @@
 	        --with-gtk=3.0 \
 	        $(SYSTEMD_SUPPORT)
 
+override_dh_strip:
+	dh_strip --dbgsym-migration='ukui-screensaver-dbg (<< 1.14.1-2~)'
+
 get-orig-source:
 	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ukui-screensaver-$1\.tar\.gz/ \
  https://github.com/ukui/ukui-screensaver/releases .*/v?(\d\S+)\.tar\.gz

## ukui-screensaver 1.1.2

=== debian/changelog ===
ukui-screensaver (1.1.2-0ubuntu1) bionic; urgency=medium

  * Set object name of auth_prompt_entry.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sun, 01 Apr 2018 15:33:12 +0800

ukui-screensaver (1.1.1-0ubuntu1) bionic; urgency=medium

  * Fix a translation file typo
  * Add "Modified by:" to three files

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 17 Mar 2018 14:01:48 +0800

ukui-screensaver (1.1.0-0ubuntu1) bionic; urgency=medium

  * Optimize the lock-dialog rendering process.
  * Remove frame shadow from the lock-dialog.
  * Add CSS stylesheets to the unlock button.
  * Migrate gtk-2.0 to gtk-3.0.
  * Update translation files.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 27 Feb 2018 15:41:35 +0800

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Kylin Team <ukui@kylinos.cn>
 Uploaders: Hao Li <lihao@kylinos.cn>,
-Build-Depends: debhelper (>= 9),
+           handsome_feng <jianfengli@ubuntukylin.com>
+Build-Depends: debhelper (>= 11),
                dpkg-dev (>= 1.16.1.1),
                intltool,
                libdbus-glib-1-dev,
@@ -13,7 +14,7 @@
                libglib2.0-dev,
                libgtk-3-dev,
                libmate-desktop-dev,
-               libmate-menu-dev,
+               libukui-menu-dev,
                libmatekbd-dev,
                libnotify-dev,
                libpam0g-dev,
@@ -29,8 +30,10 @@
                x11proto-xext-dev,
                x11proto-xf86vidmode-dev,
                xmlto,
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Homepage: http://www.ukui.org/
+Vcs-Git: https://github.com/ukui/ukui-screensaver.git
+Vcs-Browser: https://github.com/ukui/ukui-screensaver
 
 Package: ukui-screensaver
 Architecture: any
@@ -40,7 +43,7 @@
          ukui-session-manager,
          ${misc:Depends},
          ${shlibs:Depends},
-Recommends: mate-power-manager,
+Recommends: ukui-power-manager,
 Suggests: rss-glx,
           xscreensaver-data,
 Description: UKUI screen saver and locker

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUIULDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq ($(DEB_HOST_ARCH_OS),linux)
        SYSTEMD_SUPPORT=--with-systemd
else
        SYSTEMD_SUPPORT=--without-systemd
endif

%:
	dh $@

override_dh_install:
	rm -fv debian/tmp/usr/lib/*/*.la
	rm -rfv debian/tmp/usr/share/omf/
	rm -rfv debian/tmp/usr/share/help/*/fdl/
	rm -rfv debian/tmp/usr/share/help/*/gpl/
	rm -rfv debian/tmp/usr/share/help/*/lgpl/
	# For Debian we ship our own ukui-screensaver PAM configuration...
	rm -rfv debian/tmp/etc/pam.d/ukui-screensaver
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	# upstream tarball is without configure. autogen.sh will create it
	NOCONFIGURE=1 ./autogen.sh
	dh_auto_configure -- \
	        --disable-silent-rules \
	        --disable-static \
	        --with-xscreensaverdir=/usr/share/xscreensaver/config \
	        --with-xscreensaverhackdir=/usr/lib/xscreensaver \
	        --with-mit-ext \
	        --libexecdir=/usr/lib/ukui-screensaver \
	        --with-console-kit \
	        --with-libnotify \
	        --enable-locking \
	        --with-gtk=3.0 \
	        $(SYSTEMD_SUPPORT)

## ukui-screensaver 2.0.1

=== debian/changelog ===
ukui-screensaver (2.0.1-0ubuntu1) cosmic; urgency=medium

  * Update translation.
  * Change Architecture to any.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 29 Sep 2018 17:01:12 +0800

ukui-screensaver (2.0.0-0ubuntu1) cosmic; urgency=medium

  * New design implemented with Qt5.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 18 Sep 2018 16:15:43 +0800

=== debian/control ===
Source: ukui-screensaver
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kylin Team <ukui@kylinos.cn>
Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
Build-Depends: debhelper (>= 11),
               qtbase5-dev,
               libqt5x11extras5-dev,
               libpam0g-dev,
               qttools5-dev-tools,
               libglib2.0-dev,
               libx11-dev,
               libxtst-dev
Standards-Version: 4.2.1
Homepage: https://www.github.com/ukui/ukui-screensaver
Vcs-Git: https://github.com/ukui/ukui-screensaver.git
Vcs-Browser: https://github.com/ukui/ukui-screensaver

Package: ukui-screensaver
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
         ukui-session-manager | mate-session-manager,
         mate-desktop-common
Replaces: ukui-screensaver-common (<< 2.0.0)
Description: Sreensaver for UKUI desktop environment
 A simple and lightweight screensaver written by Qt5.
 The screensaver supports biometric auhentication which is
 provided by biometric-auth service.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt5
# export NO_PKG_MANGLE=1
# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/default.mk
%:
	dh $@

override_dh_auto_build:
	make all mode=release

override_dh_usrlocal:

## ukui-screensaver 2.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(ukui-screensaver)

find_package(Qt5 COMPONENTS Core Widgets DBus X11Extras)
find_package(PkgConfig REQUIRED)

set(TS_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/zh_CN.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/es.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/fr.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/pt.ts
	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/ru.ts
	)
add_custom_command(
	OUTPUT ${TS_FILES}
	COMMAND lupdate src/ -ts ${TS_FILES}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	)
add_custom_target(
	i18n_ts
	DEPENDS ${TS_FILES}
	)
add_compile_options(-fPIC)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INSTALL_PREFIX /usr)

set(Debug ON)
if(Debug)
    set(CMAKE_BUILD_TYPE "Debug")                                                                                                     
endif()

#add_subdirectory(BioAuth)
add_subdirectory(BiometricAuth)
add_subdirectory(VirtualKeyboard)
add_subdirectory(src)
add_subdirectory(i18n_ts)
add_subdirectory(data)

add_dependencies(ukui-screensaver-dialog BiometricAuth VirtualKeyboard)

=== VirtualKeyboard/CMakeLists.txt ===
find_package(Qt5 COMPONENTS Core Widgets REQUIRED)

set(CMAKE_AUTOMOC ON) 
set(CMAKE_AUTOUIC ON) 
set(CMAKE_AUTORCC ON)

qt5_add_resources(VirtualKeyboard_SRC
	src/keyboard.qrc)

set(VirtualKeyboard_SRC
	${VirtualKeyboard_SRC}
	src/cursormonitor.cpp
	src/keyboardwidget.cpp
	src/virtualkeyboard.cpp
	src/x11keyboard.cpp
	src/keyboard.qrc)

include_directories(
	${Qt5Core_INCLUDE_DIRS}
	${Qt5Widgets_INCLUDE_DIRS}
	)

add_library(VirtualKeyboard STATIC ${VirtualKeyboard_SRC})
target_link_libraries(VirtualKeyboard Qt5::Core Qt5::Widgets)

=== data/CMakeLists.txt ===
install(FILES org.ukui.screensaver.gschema.xml DESTINATION /usr/share/glib-2.0/schemas)
install(FILES ukui-screensaver.desktop DESTINATION /etc/xdg/autostart)
install(FILES ukui-screensaver.directory DESTINATION /usr/share/desktop-directories)
install(FILES ukui-screensavers.menu DESTINATION /etc/xdg/menu)

=== src/CMakeLists.txt ===
pkg_check_modules(X11 REQUIRED x11)
pkg_check_modules(XTST REQUIRED xtst)
pkg_check_modules(XCB REQUIRED xcb)
pkg_check_modules(QGS REQUIRED gsettings-qt)

find_library(PAM_LIBRARIES pam)

include_directories(${PROJECT_SOURCE_DIR}/VirtualKeyboard/src)
include_directories(${PROJECT_SOURCE_DIR}/BiometricAuth)

include_directories(
	${X11_INCLUDE_DIRS}
	${XTST_INCLUDE_DIRS}
	${XCB_INCLUDE_DIRS}
	${QGS_INCLUDE_DIRS}
	)

set(EXTRA_LIBS
	${EXTRA_LIBS}
	${PAM_LIBRARIES}
	${X11_LIBRARIES}
	${XTST_LIBRARIES}
	${XCB_LIBRARIES}
	${QGS_LIBRARIES}
	)

qt5_wrap_ui(dialog_SRC
        lockwidget.ui
        )

qt5_add_resources(dialog_SRC
	assets.qrc
	)

# 头文件中包含了Xlib.h，需要单独拿出来处理，不知道原因
qt5_wrap_cpp(dialog_SRC
	fullbackgroundwidget.h
	lockwidget.h
	authdialog.h
	screensaverwidget.h
	auth.h
	auth-pam.h
	screensaver.h
	xeventmonitor.h
	monitorwatcher.h
	configuration.h
    users.h
    displaymanager.h
	iconedit.h
	)

set(dialog_SRC
	${dialog_SRC}
	ukui-screensaver-dialog.cpp
	fullbackgroundwidget.cpp
	lockwidget.cpp
	authdialog.cpp
	screensaverwidget.cpp
	auth-pam.cpp
	xeventmonitor.cpp
	monitorwatcher.cpp
	grab-x11.cpp
	configuration.cpp
	screensaver.cpp
	users.cpp
	displaymanager.cpp
	iconedit.cpp
	)
add_executable(ukui-screensaver-dialog ${dialog_SRC})

target_link_libraries(ukui-screensaver-dialog
	Qt5::Core
	Qt5::Widgets
	Qt5::DBus
	Qt5::X11Extras
	${EXTRA_LIBS}
    BiometricAuth VirtualKeyboard
	)

qt5_wrap_cpp(backend_SRC
    interface.h
    sessionwatcher.h
    interfaceAdaptor.h
    )
set(backend_SRC
    ${backend_SRC}
    ukui-screensaver-backend.cpp
    interface.cpp
    sessionwatcher.cpp
    interfaceAdaptor.cpp
    )
add_executable(ukui-screensaver-backend ${backend_SRC})
target_link_libraries(ukui-screensaver-backend Qt5::Core Qt5::DBus)

set(command_SRC
    ukui-screensaver-command.cpp
    )
add_executable(ukui-screensaver-command ${command_SRC})
target_link_libraries(ukui-screensaver-command Qt5::Core Qt5::DBus)


install(TARGETS
	ukui-screensaver-dialog
	ukui-screensaver-backend
	ukui-screensaver-command
	DESTINATION bin)

#set(test-act_SRC
#	users.cpp
#	test-accounts.cpp
#	)
#add_executable(test-accounts ${test-act_SRC})
#target_link_libraries(test-accounts Qt5::Core Qt5::DBus)

=== debian/changelog ===
ukui-screensaver (2.0.3-1) unstable; urgency=medium

  * Change UI.
  * Add virtual keyboard.
  * Add button for switching user.
  * Remove Xext dependency.
  * Auto retry if identify failed.
  * Set the button's cursor to PointingHand.
  * Add waiting movie after respond.
  * Show black if the saver's path doesn't exist.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 05 Jan 2019 16:10:25 +0800

ukui-screensaver (2.0.2-1) unstable; urgency=medium

  * Add fr.po, pt.po, ru.po.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 23 Oct 2018 14:14:18 +0800

ukui-screensaver (2.0.1-1) UNRELEASED; urgency=medium

  * Update translation.
  * Change Architecture to any.
  * New design implemneted with Qt5.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 29 Sep 2018 17:01:12 +0800

ukui-screensaver (1.1.2-1) UNRELEASED; urgency=medium

  * Set object name of auth_prompt_entry.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 26 Jun 2018 16:10:33 +0800

ukui-screensaver (1.1.1-1) UNRELEASED; urgency=medium

  * Fix a translation file typo
  * Add "Modified by:" to three files

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sat, 17 Mar 2018 14:01:48 +0800

ukui-screensaver (1.1.0-1) UNRELEASED; urgency=medium

  * Optimize the lock-dialog rendering process.
  * Remove frame shadow from the lock-dialog.
  * Add CSS stylesheets to the unlock button.
  * Migrate gtk-2.0 to gtk-3.0.
  * Update translation files.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 27 Feb 2018 15:41:35 +0800

ukui-screensaver (1.0.3-1) UNRELEASED; urgency=medium

  * [Fixed] screensaver-preferences can't preview "Blank Screen" correctly.
  * [Improved] Change the unlock arrow to button.
  * [Improved] Set the font style of username label.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 13 Sep 2017 09:14:54 +0800

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,21 @@
 Source: ukui-screensaver
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kylin Team <ukui@kylinos.cn>
-Uploaders: handsome_feng <jianfengli@ubuntukylin.com>
-Build-Depends: debhelper (>= 11),
+Maintainer: Kylin Team <team+kylin@tracker.debian.org>
+Uploaders: Aron Xu <aron@debian.org>,
+           handsome_feng <jianfengli@ubuntukylin.com>
+Build-Depends: debhelper (>= 12),
+               cmake (>=2.6),
                qtbase5-dev,
                libqt5x11extras5-dev,
                libpam0g-dev,
+               qttools5-dev,
                qttools5-dev-tools,
                libglib2.0-dev,
                libx11-dev,
-               libxtst-dev
-Standards-Version: 4.2.1
+               libxtst-dev,
+               libgsettings-qt-dev
+Standards-Version: 4.3.0
 Homepage: https://www.github.com/ukui/ukui-screensaver
 Vcs-Git: https://github.com/ukui/ukui-screensaver.git
 Vcs-Browser: https://github.com/ukui/ukui-screensaver

## ukui-screensaver 2.0.4

=== debian/changelog ===
ukui-screensaver (2.0.4-1) experimental; urgency=medium

  * Add /etc/pam.d/ukui-screensaver-qt.
  * Generate dbus adaptor in CMake file.
  * Bugfix: failed to switch to biometric authentication if no default device.
  * Bugfix: stop authentication before suspend and start it after wake up.
  * Bugfix: not activated when idel-activation-enabled is false.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Fri, 22 Mar 2019 11:38:03 +0800

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
          ukui-session-manager | mate-session-manager,
          mate-desktop-common
 Replaces: ukui-screensaver-common (<< 2.0.0)
-Description: Sreensaver for UKUI desktop environment
+Description: Screensaver for UKUI desktop environment
  A simple and lightweight screensaver written by Qt5.
  The screensaver supports biometric auhentication which is
  provided by biometric-auth service.

## ukui-screensaver 2.0.6

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -2,3 +2,4 @@
 install(FILES ukui-screensaver.desktop DESTINATION /etc/xdg/autostart)
 install(FILES ukui-screensaver.directory DESTINATION /usr/share/desktop-directories)
 install(FILES ukui-screensavers.menu DESTINATION /etc/xdg/menu)
+install(FILES ukui-screensaver-qt DESTINATION /etc/pam.d)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
 
 find_library(PAM_LIBRARIES pam)
 
+include_directories(${PROJECT_BINARY_DIR})
 include_directories(${PROJECT_SOURCE_DIR}/VirtualKeyboard/src)
 include_directories(${PROJECT_SOURCE_DIR}/BiometricAuth)
 
@@ -77,17 +78,21 @@
     BiometricAuth VirtualKeyboard
 	)
 
+qt5_add_dbus_adaptor(backend_SRC
+    org.ukui.ScreenSaver.xml
+    interface.h
+    Interface
+    )
+
 qt5_wrap_cpp(backend_SRC
     interface.h
     sessionwatcher.h
-    interfaceAdaptor.h
     )
 set(backend_SRC
     ${backend_SRC}
     ukui-screensaver-backend.cpp
     interface.cpp
     sessionwatcher.cpp
-    interfaceAdaptor.cpp
     )
 add_executable(ukui-screensaver-backend ${backend_SRC})
 target_link_libraries(ukui-screensaver-backend Qt5::Core Qt5::DBus)

=== debian/changelog ===
ukui-screensaver (2.0.6-0ubuntu1) disco; urgency=medium

  * Bugfix only:
    - Fix the bug that the screensaver is still activated when
      sessionIdleOption is unchecked.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Fri, 12 Apr 2019 14:32:26 +0800

ukui-screensaver (2.0.5-0ubuntu1) disco; urgency=medium

  * Bugfix only:
    - Fix the wrong activated condition. (LP: #1822037)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 28 Mar 2019 16:38:31 +0800

## ukui-screensaver 2.0.9

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -87,12 +87,14 @@
 qt5_wrap_cpp(backend_SRC
     interface.h
     sessionwatcher.h
+    logind.h
     )
 set(backend_SRC
     ${backend_SRC}
     ukui-screensaver-backend.cpp
     interface.cpp
     sessionwatcher.cpp
+    logind.cpp
     )
 add_executable(ukui-screensaver-backend ${backend_SRC})
 target_link_libraries(ukui-screensaver-backend Qt5::Core Qt5::DBus)

=== debian/changelog ===
ukui-screensaver (2.0.9-0ubuntu1) eoan; urgency=medium

  * Bugfix only:
    - Don't lock when in live session. (LP: #1842855)
    - Fix the wrong background. (LP: #1836292)
    - Fix the wrong path of ukui-screensaver.menu.
    - Fix the errors when running Kydroid.
    - Fix the focus issues.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 07 Oct 2019 20:10:00 +0800

ukui-screensaver (2.0.7-1) unstable; urgency=medium

  [ Liu Yuanpeng ]
  * Set background widget on top. (LP: #1828955)
  * Set default background color. (LP: #1828982)
  * Fix that sometimes can't enter password.

  [ handsome_feng ]
  * Bump standards-vertion to 4.4.0.
  * Drop mate-session-manager.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 14 Aug 2019 09:04:48 +0800

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,8 @@
                libx11-dev,
                libxtst-dev,
                libgsettings-qt-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
+Rules-Requires-Root: no
 Homepage: https://www.github.com/ukui/ukui-screensaver
 Vcs-Git: https://github.com/ukui/ukui-screensaver.git
 Vcs-Browser: https://github.com/ukui/ukui-screensaver
@@ -23,7 +24,7 @@
 Package: ukui-screensaver
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends},
-         ukui-session-manager | mate-session-manager,
+         ukui-session-manager,
          mate-desktop-common
 Replaces: ukui-screensaver-common (<< 2.0.0)
 Description: Screensaver for UKUI desktop environment

## ukui-screensaver 2.0.10

=== debian/changelog ===
ukui-screensaver (2.0.10-1build1) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 11:20:49 +0000

ukui-screensaver (2.0.10-1) unstable; urgency=medium

  * New upstream release.
  * debian/{compat,control}
    - use debhelper-compat, bump to compat level version 12.
  * debian/control:
    - Bump standards-version to 4.4.1. No changes needed.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 11 Dec 2019 09:06:24 +0800

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Kylin Team <team+kylin@tracker.debian.org>
 Uploaders: Aron Xu <aron@debian.org>,
            handsome_feng <jianfengli@ubuntukylin.com>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 12),
                cmake (>=2.6),
                qtbase5-dev,
                libqt5x11extras5-dev,
@@ -15,7 +15,7 @@
                libx11-dev,
                libxtst-dev,
                libgsettings-qt-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Rules-Requires-Root: no
 Homepage: https://www.github.com/ukui/ukui-screensaver
 Vcs-Git: https://github.com/ukui/ukui-screensaver.git

## ukui-screensaver 2.1.1

=== i18n_ts/CMakeLists.txt ===
find_package(Qt5LinguistTools)

file(GLOB ts_files *.ts)
qt5_create_translation(qm_files ${ts_files})
add_custom_target(i18n
	DEPENDS ${qm_files}
	SOURCES ${ts_files}
	)
# 让主目标依赖翻译文件，这样才会执行i18n
add_dependencies(ukui-screensaver-dialog i18n)

install(FILES ${qm_files} DESTINATION /usr/share/ukui-screensaver/i18n_qm/)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	${XTST_LIBRARIES}
 	${XCB_LIBRARIES}
 	${QGS_LIBRARIES}
+        -lrt
 	)
 
 qt5_wrap_ui(dialog_SRC
@@ -35,6 +36,7 @@
 
 # 头文件中包含了Xlib.h，需要单独拿出来处理，不知道原因
 qt5_wrap_cpp(dialog_SRC
+        pam-tally.h
 	fullbackgroundwidget.h
 	lockwidget.h
 	authdialog.h
@@ -52,6 +54,7 @@
 
 set(dialog_SRC
 	${dialog_SRC}
+        pam-tally.c
 	ukui-screensaver-dialog.cpp
 	fullbackgroundwidget.cpp
 	lockwidget.cpp

=== debian/changelog ===
ukui-screensaver (2.1.1-1) unstable; urgency=medium

  * New upstream bugfix release:
    - Fix that long press the enter key will cause the crash.
    - Set default face to avoid empty frame.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 13 Apr 2020 16:33:05 +0800

ukui-screensaver (2.1.0-1) unstable; urgency=medium

  * New upstream bugfix release.
    - Fix the problem that the on-screen keyboard
      is displayed incorrectly when dual screen.
    - Fix the issue that the second-user cannot
      use biometrics when switching users to lock the screen.
    - Fix the lock screen issue when root user switched tty
      back and forth.
    - Keep lock screen stays on top.
    - Fix that in extended mode, login interface cannot be switched
      between two monitors with the mouse.
    * Fix the problem that the first user could not lock
      the screen when logging in two users at the same time
      by user switching.
  * debian:
    - Bump standards-vertion to 4.5.0.
    - Remove the missing file from copyright.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Thu, 26 Mar 2020 21:19:04 +0800

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                libx11-dev,
                libxtst-dev,
                libgsettings-qt-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://www.github.com/ukui/ukui-screensaver
 Vcs-Git: https://github.com/ukui/ukui-screensaver.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ukui-screensaver-$1\.tar\.gz/ \
  https://github.com/ukui/ukui-screensaver/releases .*/v?(\d\S+)\.tar\.gz

## ukui-screensaver 3.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 2.6)
 project(ukui-screensaver)
 
-find_package(Qt5 COMPONENTS Core Widgets DBus X11Extras)
+find_package(Qt5 COMPONENTS Core Widgets DBus X11Extras Xml)
 find_package(PkgConfig REQUIRED)
 
 set(TS_FILES
@@ -10,10 +10,11 @@
 	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/fr.ts
 	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/pt.ts
 	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/ru.ts
+        ${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/tr.ts
 	)
 add_custom_command(
 	OUTPUT ${TS_FILES}
-	COMMAND lupdate src/ -ts ${TS_FILES}
+	COMMAND lupdate src/ screensaver/ -ts ${TS_FILES}
 	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
 	)
 add_custom_target(
@@ -37,5 +38,8 @@
 add_subdirectory(src)
 add_subdirectory(i18n_ts)
 add_subdirectory(data)
+add_subdirectory(screensaver)
+add_subdirectory(Common)
 
-add_dependencies(ukui-screensaver-dialog BiometricAuth VirtualKeyboard)
+add_dependencies(ukui-screensaver-dialog BiometricAuth VirtualKeyboard Common)
+add_dependencies(ukui-screensaver-default Common)

=== BiometricAuth/CMakeLists.txt ===
qt5_wrap_cpp(BiometricAuth_SRC
	biometricdeviceinfo.h
	biometricproxy.h
	biometricauthwidget.h
	biometricdeviceswidget.h
	)

set(BiometricAuth_SRC
	${BiometricAuth_SRC}
	biometricdeviceinfo.cpp
	biometricproxy.cpp
	biometricauthwidget.cpp
	biometricdeviceswidget.cpp
	)

include_directories(
	${Qt5Core_INCLUDE_DIRS}
	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5DBus_INCLUDE_DIRS}
	)


add_library(BiometricAuth STATIC ${BiometricAuth_SRC})
target_link_libraries(BiometricAuth Qt5::Core Qt5::DBus Qt5::Widgets)

=== Common/CMakeLists.txt ===
qt5_wrap_cpp(Common_SRC
	autoresize.h
        checkbutton.h
        commonfunc.h
	)

set(Common_SRC
	${Common_SRC}
	autoresize.cpp
        checkbutton.cpp
        commonfunc.cpp
	)

include_directories(
	${Qt5Core_INCLUDE_DIRS}
	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5DBus_INCLUDE_DIRS}
	)


add_library(Common STATIC ${Common_SRC})
target_link_libraries(Common Qt5::Core Qt5::DBus Qt5::Widgets)

=== screensaver/CMakeLists.txt ===
pkg_check_modules(X11 REQUIRED x11)
pkg_check_modules(XTST REQUIRED xtst)
pkg_check_modules(QGS REQUIRED gsettings-qt)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/Common)

include_directories(
	${X11_INCLUDE_DIRS}
        ${XTST_INCLUDE_DIRS}
	${QGS_INCLUDE_DIRS}
	)

set(EXTRA_LIBS
	${EXTRA_LIBS}
	${X11_LIBRARIES}
        ${XTST_LIBRARIES}
	${QGS_LIBRARIES}
	Common
	)
qt5_add_resources(screensaver_SRC
	default.qrc
	)

qt5_wrap_cpp(screensaver_SRC
    chinesedate.h
    screensaver.h
    mbackground.h
    sleeptime.h
    )
set(screensaver_SRC
    ${screensaver_SRC}
    main.cpp
    chinesedate.cpp
    mbackground.cpp
    screensaver.cpp
    sleeptime.cpp
    )
add_executable(ukui-screensaver-default ${screensaver_SRC})
target_link_libraries(ukui-screensaver-default Qt5::Core Qt5::Widgets Qt5::X11Extras Qt5::Xml ${EXTRA_LIBS})

install(TARGETS
	ukui-screensaver-default
	DESTINATION lib/ukui-screensaver)

install(FILES
        language/screensaver-zh_CN.ini 
	language/screensaver-en_US.ini
        DESTINATION share/ukui-screensaver/language)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
 include_directories(${PROJECT_BINARY_DIR})
 include_directories(${PROJECT_SOURCE_DIR}/VirtualKeyboard/src)
 include_directories(${PROJECT_SOURCE_DIR}/BiometricAuth)
+include_directories(${PROJECT_SOURCE_DIR}/Common)
 
 include_directories(
 	${X11_INCLUDE_DIRS}
@@ -47,9 +48,11 @@
 	xeventmonitor.h
 	monitorwatcher.h
 	configuration.h
-    users.h
-    displaymanager.h
+        users.h
+        displaymanager.h
 	iconedit.h
+	powermanager.h
+        logind.h
 	)
 
 set(dialog_SRC
@@ -66,9 +69,11 @@
 	grab-x11.cpp
 	configuration.cpp
 	screensaver.cpp
+	powermanager.cpp
 	users.cpp
 	displaymanager.cpp
 	iconedit.cpp
+        logind.cpp
 	)
 add_executable(ukui-screensaver-dialog ${dialog_SRC})
 
@@ -78,7 +83,9 @@
 	Qt5::DBus
 	Qt5::X11Extras
 	${EXTRA_LIBS}
-    BiometricAuth VirtualKeyboard
+        BiometricAuth 
+	VirtualKeyboard 
+	Common
 	)
 
 qt5_add_dbus_adaptor(backend_SRC

=== debian/changelog ===
ukui-screensaver (3.0.1-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Sun, 27 Sep 2020 14:47:09 +0800

ukui-screensaver (3.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: bump standards-version to 4.5.0.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Wed, 12 Aug 2020 12:01:14 +0000

## ukui-screensaver 3.0.3

=== debian/changelog ===
ukui-screensaver (3.0.3-1build1) kinetic; urgency=medium

  * No-change rebuild against libopencv-core406

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Jul 2022 06:26:36 +0000

ukui-screensaver (3.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 22 Feb 2022 14:20:17 +0800

ukui-screensaver (3.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 17 Aug 2021 20:41:03 +0800

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,25 @@
 Source: ukui-screensaver
 Section: x11
 Priority: optional
-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
 Uploaders: Aron Xu <aron@debian.org>,
            handsome_feng <jianfengli@ubuntukylin.com>
 Build-Depends: debhelper-compat (= 12),
                cmake (>=2.6),
                qtbase5-dev,
                libqt5x11extras5-dev,
+               libqt5svg5-dev,
                libpam0g-dev,
                qttools5-dev,
                qttools5-dev-tools,
                libglib2.0-dev,
+               libopencv-dev,
                libx11-dev,
                libxtst-dev,
-               libgsettings-qt-dev
+               libgsettings-qt-dev,
+               libkf5windowsystem-dev,
+               libmatemixer-dev
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://www.github.com/ukui/ukui-screensaver

## ukui-screensaver 3.0.3.1

=== debian/changelog ===
ukui-screensaver (3.0.3.1-1) unstable; urgency=medium

  [ Adrian Bunk ]
  * Fix FTBFS with new glib. (Closes: #1020068)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 17 Oct 2022 19:27:09 +0800

## ukui-screensaver 3.0.3.2

=== debian/changelog ===
ukui-screensaver (3.0.3.2-1) unstable; urgency=medium

  * Use qt5_add_translation instead of qt5_create_translation.
    (Closes: #1042303)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 21 Aug 2023 15:32:43 +0800

## ukui-screensaver 3.0.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,26 @@
 cmake_minimum_required(VERSION 2.6)
 project(ukui-screensaver)
 
-find_package(Qt5 COMPONENTS Core Widgets DBus X11Extras Xml)
+find_package(Qt5 COMPONENTS Core Widgets DBus X11Extras Xml Network Svg)
 find_package(PkgConfig REQUIRED)
+find_package(OpenCV REQUIRED)
+find_package(PkgConfig)
+find_package(X11 REQUIRED)
+pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)
+pkg_check_modules(GLIB2 REQUIRED glib-2.0 gio-2.0)
+
+# 是否是intel项目
+option (USE_INTEL "intel项目" OFF)
+# 用于测试替换用的变量
+set(TEST_ON 1)
+set(TEST_OF 0)
+set(VAR "VAR_NEW")
+
+# 加入一个配置头文件，用于处理 CMake 对源码的设置
+configure_file (
+  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
+  "${CMAKE_CURRENT_BINARY_DIR}/config.h"
+)
 
 set(TS_FILES
 	${CMAKE_CURRENT_SOURCE_DIR}/i18n_ts/zh_CN.ts
@@ -23,6 +41,7 @@
 	)
 add_compile_options(-fPIC)
 
+#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 set(CMAKE_INSTALL_PREFIX /usr)
@@ -39,7 +58,9 @@
 add_subdirectory(i18n_ts)
 add_subdirectory(data)
 add_subdirectory(screensaver)
+add_subdirectory(screensaver-focus-helper)
 add_subdirectory(Common)
+add_subdirectory(KylinNM)
 
 add_dependencies(ukui-screensaver-dialog BiometricAuth VirtualKeyboard Common)
 add_dependencies(ukui-screensaver-default Common)

=== debian/changelog ===
ukui-screensaver (3.0.3.3-2build1) plucky; urgency=medium

  * No-change rebuild for opencv 4.10.0.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 19 Feb 2025 08:50:41 +0000

ukui-screensaver (3.0.3.3-2) unstable; urgency=medium

  * d/patches: fix-security-issue-predictable-filenames-with-system.
    (Closes: #1071521)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Fri, 24 May 2024 16:18:09 +0800

ukui-screensaver (3.0.3.3-1) unstable; urgency=medium

  * Fix implicit declaration of function. (Closes: #1066638)
  * Update debian/watch.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 02 Apr 2024 19:23:57 +0800

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt5
# export NO_PKG_MANGLE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/default.mk
%:
	dh $@

override_dh_usrlocal:
